REM
REM  Some debuging functions...
REM

DIM SHARED DebugCpuPause AS BYTE = 0   ' Pause at each CPU step
DIM SHARED DebugLastSpriteDump(1 TO 2) AS UINTEGER
DIM SHARED DebugLastPaletteDump AS UINTEGER
DIM SHARED DebugNextCpuSpeedDump AS ULONGINT

#INCLUDE ONCE "vbcompat.bi"

SUB DebugShowCPUspeed()
  DIM AS SINGLE CpuSpeed
  IF TotalCycles > DebugNextCpuSpeedDump THEN
    DebugNextCpuSpeedDump += 4100000
    CpuSpeed = (TotalCycles / (TIMER - EmulationStartTimer)) / 1000000   ' MHz
    LOCATE 43, 2: PRINT FORMAT(CpuSpeed, "0.00"); " MHz (" & INT((CpuSpeed / 4.194304) * 100) & "%)  ";
    LOCATE 44, 2: PRINT "DropCycles: " & DropCycles;
  END IF
END SUB


SUB InitDebug()
  LOCATE 35, 2: PRINT "Palettes:";
  LOCATE 36, 2: PRINT "BGP:";
  LOCATE 38, 2: PRINT "OB0:";
  LOCATE 40, 2: PRINT "OB1:";
  LOCATE 60, 2: PRINT "Sprite OBJ table #1 [&h8000..&h8FFF]:";
  LOCATE 82, 2: PRINT "Sprite OBJ table #2 [&h8800..&h97FF]:";
END SUB


SUB DebugSpriteDump(TileTableType AS BYTE)
  DIM AS INTEGER x, y, z, t, globalYpos, TableAddr
  SELECT CASE TileTableType
    CASE 1 ' Tile Table #1 (8000..8FFF)
      TableAddr = &h8000
    CASE 2 ' Tile Table #2 (8800..97FF)
      TableAddr = &h8800
    CASE ELSE
      PRINT "Error #957" : END
  END SELECT
  IF DebugLastSpriteDump(TileTableType) <> INT(TIMER) THEN ' Dump sprite table onscreen
    DebugLastSpriteDump(TileTableType) = INT(TIMER)
    FOR z = 0 TO 255
      IF z > &h00 THEN globalYpos = 490 + ((TileTableType - 1) * 170) + 000 : t = z - &h00
      IF z > &h20 THEN globalYpos = 490 + ((TileTableType - 1) * 170) + 020 : t = z - &h20
      IF z > &h40 THEN globalYpos = 490 + ((TileTableType - 1) * 170) + 040 : t = z - &h40
      IF z > &h60 THEN globalYpos = 490 + ((TileTableType - 1) * 170) + 060 : t = z - &h60
      IF z > &h80 THEN globalYpos = 490 + ((TileTableType - 1) * 170) + 080 : t = z - &h80
      IF z > &hA0 THEN globalYpos = 490 + ((TileTableType - 1) * 170) + 100 : t = z - &hA0
      IF z > &hC0 THEN globalYpos = 490 + ((TileTableType - 1) * 170) + 120 : t = z - &hC0
      IF z > &hE0 THEN globalYpos = 490 + ((TileTableType - 1) * 170) + 140 : t = z - &hE0
      FOR y = 0 TO 7
        FOR x = 0 TO 1
          PSET (0 + (x * 4) + (t*9), y + globalYpos), ScreenPalette(GbPalette((MemoryRead(TableAddr + (z * 16) + (y * 2) + x) AND &b11000000) SHR 6, 1))
          PSET (1 + (x * 4) + (t*9), y + globalYpos), ScreenPalette(GbPalette((MemoryRead(TableAddr + (z * 16) + (y * 2) + x) AND &b00110000) SHR 4, 1))
          PSET (2 + (x * 4) + (t*9), y + globalYpos), ScreenPalette(GbPalette((MemoryRead(TableAddr + (z * 16) + (y * 2) + x) AND &b00001100) SHR 2, 1))
          PSET (3 + (x * 4) + (t*9), y + globalYpos), ScreenPalette(GbPalette(MemoryRead(TableAddr + (z * 16) + (y * 2) + x) AND &b00000011, 1))
        NEXT x
      NEXT y
    NEXT z
  END IF
END SUB


SUB DebugOamDump()
  REM  Dumps the content of the OAM (Object Attribute Map at FE00) on screen
END SUB


SUB DebugPaletteDump()
  IF INT(DebugLastPaletteDump) <> INT(TIMER) THEN
    DIM tPalette(0 TO 3) AS UINTEGER
    DIM AS INTEGER x
    DebugLastPaletteDump = TIMER
    FOR x = 0 TO 2
      tPalette(0) = ScreenPalette(IoRegisters(&hFF47 + x) AND &b00000011)
      tPalette(1) = ScreenPalette((IoRegisters(&hFF47 + x) AND &b00001100) SHR 2)
      tPalette(2) = ScreenPalette((IoRegisters(&hFF47 + x) AND &b00110000) SHR 4)
      tPalette(3) = ScreenPalette((IoRegisters(&hFF47 + x) AND &b11000000) SHR 6)
      LINE (40, 280 + x * 15)-STEP(10,10), tPalette(0), BF
      LINE (52, 280 + x * 15)-STEP(10,10), tPalette(1), BF
      LINE (64, 280 + x * 15)-STEP(10,10), tPalette(2), BF
      LINE (76, 280 + x * 15)-STEP(10,10), tPalette(3), BF
    NEXT x
  END IF
END SUB


SUB PrintDebug(DebugLog AS STRING)
  #IFDEF DEBUGMODE
    PRINT DebugLog
  #ENDIF
END SUB
